#include <XBee.h>

// Initalization functions
int InitXBee(uint16_t address,  uint16_t PanID);

// sending functions
int sendAtCommand(AtCommandRequest atRequest);

int sendData(uint16_t SendAddr, uint8_t payload[], int payload_size);

int sentHKpkt(uint16_t addr);

// reading functions
String readMsg_str();

int readMsg(uint8_t data[], uint16_t timeout);

// utility functions
String data2string(uint8_t data[]);

uint8_t addToTlm(uint8_t val, uint8_t payload[], uint8_t start_pos);
uint8_t addToTlm(int8_t val, uint8_t payload[], uint8_t start_pos);

uint8_t addToTlm(uint16_t val, uint8_t payload[], uint8_t start_pos);
uint8_t addToTlm(int16_t val, uint8_t payload[], uint8_t start_pos);

uint8_t addToTlm(uint32_t val, uint8_t payload[], uint8_t start_pos);
uint8_t addToTlm(int32_t val, uint8_t payload[], uint8_t start_pos);

uint8_t addToTlm(float val, uint8_t payload[], uint8_t start_pos);

uint8_t extract_uint8(uint8_t data[], uint8_t start_pos);
int8_t extract_int8(uint8_t data[], uint8_t start_pos);

uint16_t extract_uint16(uint8_t data[], uint8_t start_pos);
int16_t extract_int16(uint8_t data[], uint8_t start_pos);

uint32_t extract_uint32(uint8_t data[], uint8_t start_pos);
int32_t extract_int32(uint8_t data[], uint8_t start_pos);

float extract_float(uint8_t data[], uint8_t start_pos);
